Include "SoftPixelEngineWrapper.bb"

UseOpenGL()

; Set log file for debugging
OpenDebugLog(True, "DebugLog.txt")

; Initialization
Graphics3D(800,600, 32, 0)
AppTitle("simple projector")

Global cam = CreateCamera()
PositionEntity cam, 0, 0, 0
CameraClsColor cam,15,15,15
light=CreateLight()
TurnEntity light,45,0,0

; Create the teapot
obj = Createtorus(16,3,.5)
EntityColor obj,0,0,255

;scene
room=CreateCube()
EntityColor room,70,155,55
FlipMesh room
ScaleMesh room,10,10,10

;projector
proj=LoadTexture("projector.jpg",1+32+256)
EntityTexture obj,proj,0,0
EntityTexture room,proj,0,0
; Load the shader:
ShdFile$="projector"

Global Shader = LoadShader(ShdFile$+".Vert", ShdFile$+".Frag", "", "")
; Set the shader constants

;generation matrix
GenerationMatrix=ViewMatrix()
MatrixReset(GenerationMatrix)
;view matrix
InViewMatrix=WorldMatrix()   
MatrixReset(InViewMatrix)
MatrixTranslate(InViewMatrix, .5, .5, 0)
MatrixScale(InViewMatrix, .1, -.1, .1)
; Set the shader constants   
SetShaderMat(shader,"TexGenMat",GenerationMatrix)
SetShaderMat(shader,"InvViewMat",InViewMatrix)
SetShaderInt(shader,"projMap",0)

   
; setshader to model
SetShader(obj, Shader)
SetShader(room, Shader)

While Not KeyDown(1)

   TurnEntity(obj, 0.01, -0.015, 0)
   MoveCameraFree(cam, 0.01, 0.25, 90.0, False)   

   RenderWorld

   Color 255, 255, 255, 110   
   Text 10, 10, WrapperVersion$()   
   Text 10, 20, VideoDriver%()
   Text 10, 30, VDVersion$()
   Text 10, 40, VDVendor$()
   Text 10, 50, VDRenderer$()

   Flip
   
Wend

EndGraphics
End